<?php global $APP_KEY, $APP_SECRET;
$APP_KEY='zaQudweygpqNJUQ2';
$APP_SECRET='GbCxdyHoscZn5TFuoBHrJ1W0CUc8yY72';
require_once(dirname(__FILE__).'/../OAuth.php');

date_default_timezone_set('Asia/Chongqing');

/** 
 * 网易微博操作类 
 * 
 * @package sae 
 * @author Easy Chen 
 * @version 1.0 
 */ 
class Weibo163Client 
{ 
    /** 
     * 构造函数 
     *  
     * @access public 
     * @param mixed $akey 微博开放平台应用APP KEY 
     * @param mixed $skey 微博开放平台应用APP SECRET 
     * @param mixed $accecss_token OAuth认证返回的token 
     * @param mixed $accecss_token_secret OAuth认证返回的token secret 
     * @return void 
     */ 
    function __construct( $akey , $skey , $accecss_token , $accecss_token_secret ) 
    { 
        $this->oauth = new Weibo163OAuth( $akey , $skey , $accecss_token , $accecss_token_secret ); 
    } 

    /** 
     * 最新公共微博 
     *  
     * @access public 
     * @return array 
     */ 
    function public_timeline() 
    { 
        return $this->oauth->get('http://api.t.163.com/statuses/public_timeline.json'); 
    } 

    /** 
     * 最新关注人微博 
     *  
     * @access public 
     * @return array 
     */ 
    function friends_timeline() 
    { 
        return $this->home_timeline(); 
    } 

    /** 
     * 最新关注人微博 
     *  
     * @access public 
     * @return array 
     */ 
    function home_timeline($count = 30 ,$sinace = false,$max=false,$trim=false ) 
    { 
        return $this->request_163('http://api.t.163.com/statuses/home_timeline.json',  $count,$sinace ,$max,$trim); 
    } 

    /** 
     * 最新 @用户的 
     *  
     * @access public 
     * @param int $count 每次返回的最大记录数（即页面大小），不大于200，默认为30。 
     * @return array 
     */ 
    function mentions( $count = 30 ,$sinace = false,$max=false,$trim=false ) 
    { 
        return $this->request_163( 'http://api.t.163.com/statuses/mentions.json' ,  $count,$sinace ,$max,$trim ); 
    } 


    /** 
     * 发表微博 
     *  
     * @access public 
     * @param mixed $text 要更新的微博信息。 
     * @return array 
     */ 
    function update( $text,$source ="<a href=\"http://t.177wan.com\">177wan应用试验基地</a>" ) 
    { 
        //  http://api.t.163.com/statuses/update.json 
        $param = array(); 
        $param['status'] = $text; 
		$param['source'] = $source; 

        return $this->oauth->post( 'http://api.t.163.com/statuses/update.json' , $param ); 
    }
    
    /** 
     * 发表图片微博 
     *  
     * @access public 
     * @param string $text 要更新的微博信息。 
     * @param string $text 要发布的图片路径,支持url。[只支持png/jpg/gif三种格式,增加格式请修改get_image_mime方法] 
     * @return array 
     */ 
    function upload( $text, $pic_path,$source ="<a href=\"http://t.177wan.com\">177wan应用试验基地</a>"  ) 
    { 
      $param = array(); 
      $param['pic'] = "@".$pic_path;
	  $pic = $this->oauth->post( 'http://api.t.163.com/statuses/upload.json' , $param , true );
      $param1 = array(); 
      $param1['status'] = $text." ".$pic['upload_image_url']; 
	  $param1['source'] = $source; 
       return $this->oauth->post( 'http://api.t.163.com/statuses/update.json' , $param1 );   
    } 

    /** 
     * 获取单条微博 
     *  
     * @access public 
     * @param mixed $sid 要获取已发表的微博ID 
     * @return array 
     */ 

    function show_status( $sid ) 
    { 
        return $this->oauth->get( 'http://api.t.163.com/statuses/show/' . $sid . '.json' ); 
    } 


    /** 
     * 返回当前登录用户未读的新消息数量。
     *  
     * @return array 
     */ 

	    function latest() 
    { 
        return $this->oauth->get( 'http://api.t.163.com/reminds/message/latest.json' ); 
    } 
    /** 
     * 删除微博 
     *  
     * @access public 
     * @param mixed $sid 要删除的微博ID 
     * @return array 
     */ 
    function delete( $sid ) 
    { 
        return $this->destroy( $sid ); 
    } 

    /** 
     * 删除微博 
     *  
     * @access public 
     * @param mixed $sid 要删除的微博ID 
     * @return array 
     */ 
    function destroy( $sid ) 
    { 
        return $this->oauth->post( 'http://api.t.163.com/statuses/destroy/' . $sid . '.json' ); 
    } 
   /** 
     * 被谁转发过 
     *  
     * @access public 
     * @param mixed $sid 要查询的微博ID 
     * @return array 
     */ 
	    function retweeted_by( $sid,$count=false ) 
    { 
		  $param = array(); 
        if($count)$param['count'] = $count; 
        return $this->oauth->get( 'http://api.t.163.com/statuses/' . $sid . '/retweeted_by.json' ); 
    } 

    /** 
     * 个人资料 
     *  
     * @access public 
     * @param mixed $uid_or_name 用户UID或微博昵称。 
     * @return array 
     */ 
    function show_user_id( $id_or_screen_name) 
    { 
		  $param = array(); 
        $param['id'] = $id_or_screen_name; 
        return $this->oauth->get( 'http://api.t.163.com/users/show.json', $param); 
    } 

	   function show_user_name( $name) 
    { 
		  $param = array(); 
        $param['name'] = $name; 
        return $this->oauth->get( 'http://api.t.163.com/users/show.json', $param); 
    } 
}

class Weibo163OAuth { 
    /** 
     * Contains the last HTTP status code returned.  
     * 
     * @ignore 
     */ 
    public $http_code; 
    /** 
     * Contains the last API call. 
     * 
     * @ignore 
     */ 
    public $url; 
    /** 
     * Set up the API root URL. 
     * 
     * @ignore 
     */ 
    public $host = "http://api.t.163.com/"; 
    /** 
     * Set timeout default. 
     * 
     * @ignore 
     */ 
    public $timeout = 30; 
    /**  
     * Set connect timeout. 
     * 
     * @ignore 
     */ 
    public $connecttimeout = 30;  
    /** 
     * Verify SSL Cert. 
     * 
     * @ignore 
     */ 
    public $ssl_verifypeer = FALSE; 
    /** 
     * Respons format. 
     * 
     * @ignore 
     */ 
    public $format = 'json'; 
    /** 
     * Decode returned json data. 
     * 
     * @ignore 
     */ 
    public $decode_json = TRUE; 
    /** 
     * Contains the last HTTP headers returned. 
     * 
     * @ignore 
     */ 
    public $http_info; 
    /** 
     * Set the useragnet. 
     * 
     * @ignore 
     */ 
    public $useragent = 'Sae T OAuth v0.2.0-beta2'; 
    /* Immediately retry the API call if the response was not successful. */ 
    //public $retry = TRUE; 
    



    /** 
     * Set API URLS 
     */ 
    /** 
     * @ignore 
     */ 
    function accessTokenURL()  { return 'http://api.t.163.com/oauth/access_token'; } 
    /** 
     * @ignore 
     */ 
    function authenticateURL() { return 'http://api.t.163.com/oauth/authenticate'; } 
    /** 
     * @ignore 
     */ 
    function authorizeURL()    { return 'http://api.t.163.com/oauth/authorize'; } 
    /** 
     * @ignore 
     */ 
    function requestTokenURL() { return 'http://api.t.163.com/oauth/request_token'; } 


    /** 
     * Debug helpers 
     */ 
    /** 
     * @ignore 
     */ 
    function lastStatusCode() { return $this->http_status; } 
    /** 
     * @ignore 
     */ 
    function lastAPICall() { return $this->last_api_call; } 

    /** 
     * construct WeiboOAuth object 
     */ 
    function __construct($consumer_key, $consumer_secret, $oauth_token = NULL, $oauth_token_secret = NULL) { 
        $this->sha1_method = new OAuthSignatureMethod_HMAC_SHA1(); 
        $this->consumer = new OAuthConsumer($consumer_key, $consumer_secret); 
        if (!empty($oauth_token) && !empty($oauth_token_secret)) { 
            $this->token = new OAuthConsumer($oauth_token, $oauth_token_secret); 
        } else { 
            $this->token = NULL; 
        } 
    } 


    /** 
     * Get a request_token from Weibo 
     * 
     * @return array a key/value array containing oauth_token and oauth_token_secret 
     */ 
    function getRequestToken($oauth_callback = NULL) { 
        $parameters = array(); 
        if (!empty($oauth_callback)) { 
        }  

        $request = $this->oAuthRequest($this->requestTokenURL(), 'GET', $parameters); 
        $token = OAuthUtil::parse_parameters($request); 
        $this->token = new OAuthConsumer($token['oauth_token'], $token['oauth_token_secret']); 
        return $token; 
    } 

    /** 
     * Get the authorize URL 
     * 
     * @return string 
     */ 
    function getAuthorizeURL($token, $sign_in_with_Weibo = TRUE , $url) { 
        if (is_array($token)) { 
            $token = $token['oauth_token']; 
        } 
        if (empty($sign_in_with_Weibo)) { 
            return $this->authorizeURL() . "?oauth_token={$token}&oauth_callback=" . urlencode($url); 
        } else { 
            return $this->authenticateURL() . "?oauth_token={$token}&oauth_callback=". urlencode($url); 
        } 
    } 

    /** 
     * Exchange the request token and secret for an access token and 
     * secret, to sign API calls. 
     * 
     * @return array array("oauth_token" => the access token, 
     *                "oauth_token_secret" => the access secret) 
     */ 
    function getAccessToken($oauth_verifier = FALSE, $oauth_token = false) { 
        $parameters = array(); 
        if (!empty($oauth_verifier)) { 
            $parameters['oauth_verifier'] = $oauth_verifier; 
        } 


        $request = $this->oAuthRequest($this->accessTokenURL(), 'GET', $parameters); 
        $token = OAuthUtil::parse_parameters($request); 
        $this->token = new OAuthConsumer($token['oauth_token'], $token['oauth_token_secret']); 
        return $token; 
    } 

    /** 
     * GET wrappwer for oAuthRequest. 
     * 
     * @return mixed 
     */ 
    function get($url, $parameters = array()) { 
        $response = $this->oAuthRequest($url, 'GET', $parameters); 
        if ($this->format === 'json' && $this->decode_json) { 
            return json_decode($response, true); 
        } 
        return $response; 
    } 

    /** 
     * POST wreapper for oAuthRequest. 
     * 
     * @return mixed 
     */ 
    function post($url, $parameters = array() , $multi = false) { 
        
        $response = $this->oAuthRequest($url, 'POST', $parameters , $multi ); 
        if ($this->format === 'json' && $this->decode_json) { 
            return json_decode($response, true); 
        } 
        return $response; 
    } 

    /** 
     * DELTE wrapper for oAuthReqeust. 
     * 
     * @return mixed 
     */ 
    function delete($url, $parameters = array()) { 
        $response = $this->oAuthRequest($url, 'DELETE', $parameters); 
        if ($this->format === 'json' && $this->decode_json) { 
            return json_decode($response, true); 
        } 
        return $response; 
    } 

    /** 
     * Format and sign an OAuth / API request 
     * 
     * @return string 
     */ 
    function oAuthRequest($url, $method, $parameters , $multi = false) { 

        if (strrpos($url, 'http://') !== 0 && strrpos($url, 'http://') !== 0) { 
            $url = "{$this->host}{$url}.{$this->format}"; 
        } 

        // echo $url ; 
        $request = OAuthRequest::from_consumer_and_token($this->consumer, $this->token, $method, $url, $parameters); 
        $request->sign_request($this->sha1_method, $this->consumer, $this->token); 
        switch ($method) { 
        case 'GET': 
            //echo $request->to_url(); 
            return $this->http($request->to_url(), 'GET'); 
        default: 
            return $this->http($request->get_normalized_http_url(), $method, $request->to_postdata($multi) , $multi,$request->to_header() ); 
        } 
    } 

    /** 
     * Make an HTTP request 
     * 
     * @return string API results 
     */ 
    function http($url, $method, $postfields = NULL , $multi = false,$headermulti = "") { 
        $this->http_info = array(); 
        $ci = curl_init(); 
        /* Curl settings */ 
        curl_setopt($ci, CURLOPT_USERAGENT, $this->useragent); 
        curl_setopt($ci, CURLOPT_CONNECTTIMEOUT, $this->connecttimeout); 
        curl_setopt($ci, CURLOPT_TIMEOUT, $this->timeout); 
        curl_setopt($ci, CURLOPT_RETURNTRANSFER, TRUE); 

        curl_setopt($ci, CURLOPT_SSL_VERIFYPEER, $this->ssl_verifypeer); 

        curl_setopt($ci, CURLOPT_HEADERFUNCTION, array($this, 'getHeader')); 

        curl_setopt($ci, CURLOPT_HEADER, FALSE); 

        switch ($method) { 
        case 'POST': 
            curl_setopt($ci, CURLOPT_POST, TRUE); 
            if (!empty($postfields)) { 
                curl_setopt($ci, CURLOPT_POSTFIELDS, $postfields); 
                //echo "=====post data======\r\n";
                //echo $postfields;
            } 
            break; 
        case 'DELETE': 
            curl_setopt($ci, CURLOPT_CUSTOMREQUEST, 'DELETE'); 
            if (!empty($postfields)) { 
                $url = "{$url}?{$postfields}"; 
            } 
        } 

        $header_array = array(); 
        


        $header_array2=array(); 
        if( $multi ) 
        	$header_array2 = array("Content-Type: multipart/form-data; boundary=" . OAuthUtil::$boundary , "Expect: ");
        foreach($header_array as $k => $v) 
            array_push($header_array2,$k.': '.$v); 
	     array_push($header_array2,$headermulti); 

        curl_setopt($ci, CURLOPT_HTTPHEADER, $header_array2 ); 
        curl_setopt($ci, CURLINFO_HEADER_OUT, TRUE ); 

        //echo $url."<hr/>"; 

        curl_setopt($ci, CURLOPT_URL, $url); 

        $response = curl_exec($ci); 
        $this->http_code = curl_getinfo($ci, CURLINFO_HTTP_CODE); 
        $this->http_info = array_merge($this->http_info, curl_getinfo($ci)); 
        $this->url = $url; 

        //echo '=====info====='."\r\n";
        //print_r( curl_getinfo($ci) ); 
        
        //echo '=====$response====='."\r\n";
        //print_r( $response ); 

        curl_close ($ci); 
        return $response; 
    } 

    /** 
     * Get the header info to store. 
     * 
     * @return int 
     */ 
    function getHeader($ch, $header) { 
        $i = strpos($header, ':'); 
        if (!empty($i)) { 
            $key = str_replace('-', '_', strtolower(substr($header, 0, $i))); 
            $value = trim(substr($header, $i + 2)); 
            $this->http_header[$key] = $value; 
        } 
        return strlen($header); 
    } 
} 

/* 2011.04.12 */
function smc_163_confirm(){
	global $APP_KEY, $APP_SECRET;
	$to = new Weibo163OAuth($APP_KEY, $APP_SECRET, $_GET['oauth_token'],$_SESSION['smc_oauth_token_secret']);
	$tok = $to->getAccessToken($_REQUEST['oauth_verifier']);
	$to = new Weibo163OAuth($APP_KEY, $APP_SECRET, $tok['oauth_token'], $tok['oauth_token_secret']);
	$weiboInfo = $to->get('http://api.t.163.com/account/verify_credentials.json', array());
	if($weiboInfo['error_code']=='401'){
		echo '<script type="text/javascript">alert("Something error!");window.close();</script>';
		return;
	}
	$screen_name=$weiboInfo['screen_name']?$weiboInfo['screen_name']:$weiboInfo['name'];
	smc_163_login($weiboInfo['profile_image_url'].'|'.$weiboInfo['name'].'|'.$screen_name.'|http://t.163.com/n/'.$weiboInfo['name'].'|'.$tok['oauth_token'] .'|'.$tok['oauth_token_secret']); 
}
function smc_163_login($Userinfo) {
	$userinfo = explode('|',$Userinfo);
	if(count($userinfo) < 6) {
		wp_die("An error occurred while trying to contact Sina Connect.");
	}
	$userdata = array(
		'user_pass' => wp_generate_password(),
		'user_login' => '163_t_'.$userinfo[1],
		'display_name' => $userinfo[2],
		'user_url' => $userinfo[3],
		'user_email' => $userinfo[1].'@t.163.com'
	);
	
	if(!function_exists('wp_insert_user')){
		include_once( ABSPATH . WPINC . '/registration.php' );
	} 
	$wpuid = get_user_by_login($userdata['user_login']);

	if(!$wpuid){
		if($userinfo[0]){
			$wpuid = wp_insert_user($userdata);
			smc_new_user_email($userdata,'网易微博');
			if($wpuid){
				$smc_array = array (
					"smcid" => $userinfo[0],
					"smcweibo" => '163weibo',
					"oauth_access_token" => $userinfo[4],
					"oauth_access_token_secret" => $userinfo[5],
				);
				update_usermeta($wpuid, 'smcdata', $smc_array);
			}
		}
	} else {
		$smc_array = array (
			"smcid" => $userinfo[0],
			"smcweibo" => '163weibo',
			"oauth_access_token" => $userinfo[4],
			"oauth_access_token_secret" => $userinfo[5],
		);
		update_usermeta($wpuid, 'smcdata', $smc_array);
	}
  
	if($wpuid) {
		wp_set_auth_cookie($wpuid, true, false);
		wp_set_current_user($wpuid);
	}
}
function smc_163_getAccessToken($oauth_verifier,$oauth_token,$token_secret){
	global $APP_KEY, $APP_SECRET;
	$to=new Weibo163OAuth($APP_KEY, $APP_SECRET, $oauth_token, $token_secret);
	return $to->getAccessToken($oauth_verifier);
}
function smc_163_weibo_update($content,$thumb,$tok){//-8737476567477287845
	global $APP_KEY, $APP_SECRET;
	$to=new Weibo163OAuth($APP_KEY, $APP_SECRET, $tok['oauth_token'], $tok['oauth_token_secret']);
	if($thumb){
		$pic = $to->post('http://api.t.163.com/statuses/upload.json',array('pic'=>'@'.$thumb),true);
		if($pic['error_code']){
			return smc_163_weibo_update($content,'',$tok);
		}
		$resp = $to->post('http://api.t.163.com/statuses/update.json',array('status'=>$content.' '.$pic['upload_image_url'],'source'=>'<a href="http://www.qiqiboy.com">SocialMedias</a>'));
	}else{
		$resp = $to->post('http://api.t.163.com/statuses/update.json',array('status'=>$content,'source'=>'<a href="http://www.qiqiboy.com">SocialMedias</a>'));
	}
	if($resp['id']){
		return $resp['id'];
	}else{
		return false;
	}
}
function smc_163_weibo_repost($p,$smcdata){//-8737476567477287845
	global $APP_KEY, $APP_SECRET;
	if(!$p['weibosync']){
		return smc_163_weibo_update('我对《'.$p['title'].'》的观点: '.$p['comment'].' - '.$p['url'],'',array('oauth_token'=>$smcdata['oauth_access_token'],'oauth_token_secret'=>$smcdata['oauth_access_token_secret']));
	}
	$to=new Weibo163OAuth($APP_KEY, $APP_SECRET, $smcdata['oauth_access_token'], $smcdata['oauth_access_token_secret']);
	$param=array();
	$param['status']='我对《'.$p['title'].'》的观点: '.$p['comment'].' - '.$p['url'];
	$param['id']=$p['weibosync'];
	$param['source']='<a href="http://www.qiqiboy.com">SocialMedias</a>';
	$param['is_retweet']=1;//print_r($param);die();
	$resp = $to->post('http://api.t.163.com/statuses/reply.json',$param);//print_r($resp);
}