<?php
if(get_option('smc_weibo_options')==''){
	add_action('admin_notices', 'lwtt_warning_sina');
	function lwtt_warning_sina(){
		echo '<div class="error"><p>请到<a href="'.menu_page_url('smc_options',false).'">Social Medias Connect</a>更新插件设置</p></div>';
	}
}
add_action('init', 'smc_init');
function smc_init(){
	if (session_id() == "") {
		session_start();
	}
	if(!is_user_logged_in()) {	
        if(isset($_GET['oauth_token'])){
			$weibo=$_SESSION["smc_weibo"];
			switch($weibo){
				case 'sinaweibo':
						include dirname(__FILE__).'/sinaweibo/sinaOAuth.php';
						smc_sina_confirm();
						break;
				case 'qqweibo':
						include dirname(__FILE__).'/qqweibo/qqOAuth.php';
						smc_qq_confirm();
						break;
				case 'douban':
						include dirname(__FILE__).'/douban/doubanOAuth.php';
						smc_douban_confirm();
						break;
				case 'sohuweibo':
						include dirname(__FILE__).'/sohuweibo/sohuOAuth.php';
						smc_sohu_confirm();
						break;
				case '163weibo':
						include dirname(__FILE__).'/163weibo/163OAuth.php';
						smc_163_confirm();
						break;
				default:break;
			}
        } 
    }
	$smc_opt=get_option('smc_weibo_options');
	if($smc_opt['smc_auto_connect']){
		add_action('comment_form', 'smc_connect');
		add_action("login_form", "smc_connect");
	}
}

add_action("wp_head", "smc_wp_head");
add_action("admin_head", "smc_wp_head");
add_action("admin_head", "smc_wp_css");
add_action("login_head", "smc_wp_head");
function smc_wp_head(){
	$weiboopt=get_option('smc_weibo_options');
    if(is_user_logged_in()) {
        if(isset($_GET['oauth_token'])){
			echo '<script type="text/javascript">window.opener.smc_reload("");window.close();</script>';
       }
	}elseif(empty($weiboopt)||$weiboopt['smc_auto_js']){
		smc_wp_css();
		echo '<script type="text/javascript" src="'.(WP_PLUGIN_URL.'/'.dirname(plugin_basename (__FILE__))).'/js/social-medias-connect.js"></script>';
		echo '<script type="text/javascript">if(window.smcJS){if(window.jQuery)jQuery(document).ready(function(){smcJS.smc("'.htmlspecialchars($weiboopt['smc_weibo_notice']).'");});else smcJS.documentReady(function(){smcJS.smc("'.htmlspecialchars($weiboopt['smc_weibo_notice']).'");});}</script>';
	}
}
function smc_wp_css(){
	echo '<link rel="stylesheet" media="all" href="'.(WP_PLUGIN_URL.'/'.dirname(plugin_basename (__FILE__))).'/style.css"></link>';
}

function smc_connect($args=""){
	$weiboopt=get_option('smc_weibo_options');
	global $smc_loaded;
	if($smc_loaded){
		return;
	}
	$defaults=array(
		"admin"=>"",
		"callback_url"=>"",
		"weibos"=>array()
	);
	$r = wp_parse_args( $args, $defaults );
	extract( $r );

	if(is_user_logged_in()){
		global $user_ID;
		$smcdata = get_user_meta($user_ID, 'smcdata',true);
		$weibotok=get_option('weibo_access_token');
		if($weibo=$smcdata['smcweibo']){
			switch($weibo){
				case 'sinaweibo':
						$weibo='新浪微博';
						break;
				case 'qqweibo':
						$weibo='腾讯微博';
						break;
				case 'douban':
						$weibo='豆瓣';
						break;
				case 'sohuweibo':
						$weibo='搜狐微博';
						break;
				case '163weibo':
						$weibo='网易微博';
						break;
				default:$weibo='微博';
						break;
			}
?>		<p id="smc_sync" class="smc_button smc_<?php echo $smcdata['smcweibo']; ?>"><input name="post_to_socialmedias" type="checkbox" checked="checked" id="post_to_socialmedias" value="1"  /><label for="post_to_socialmedias">同步到<?php echo $weibo; ?></label></p>
<?php	return;
		}
		if(!$r['admin'])return;
	}else{
		$allows=get_option('smc_allowed_weibo');
	}
	$smc_url = WP_PLUGIN_URL.'/'.dirname(plugin_basename (__FILE__));
	$callback=$r['callback_url']?"&callback_url=".$r['callback_url']:"";
?>
	<script type="text/javascript">
    window.smc_reload=function(){
       var url=location.href.replace(/#.*|&delete.*/i,'')+'#smc_sync';
       location.href = url;
       setTimeout(function(){location.reload()},1300);
    }
    </script>	
	<style type="text/css"> 
	.smc_button img{ border:none;}
    </style>
	<ul id="smc_connect_area" class="smc_button"<?php if(!is_user_logged_in()&&(empty($weiboopt)||$weiboopt['smc_auto_js']))echo ' style="display:none;"'; ?>>
		<?php if((isset($weibotok)&&!$weibotok['sinaweibo'])||(isset($allows)&&(empty($allows)||$allows['sinaweibo']))): ?><li><img class="smc_img" onclick='window.open("<?php echo $smc_url; ?>/start-connect.php?socialmedia=sinaweibo<?php echo $callback; ?>", "dcWindow","width=800,height=600,left=150,top=100,scrollbar=no,resize=no");return false;' src="<?php echo $smc_url; ?>/images/sina_button.png" alt="使用新浪微博登陆" /></li><?php endif; ?>
		<?php if((isset($weibotok)&&!$weibotok['qqweibo'])||(isset($allows)&&(empty($allows)||$allows['qqweibo']))): ?><li><img class="smc_img" onclick='window.open("<?php echo $smc_url; ?>/start-connect.php?socialmedia=qqweibo<?php echo $callback; ?>", "dcWindow","width=840,height=900,left=150,top=100,scrollbar=no,resize=no");return false;' src="<?php echo $smc_url; ?>/images/qq_button.png" alt="使用腾讯微博登陆" /></li><?php endif; ?>
		<?php if((isset($weibotok)&&!$weibotok['sohuweibo'])||(isset($allows)&&(empty($allows)||$allows['sohuweibo']))): ?><li><img class="smc_img" onclick='window.open("<?php echo $smc_url; ?>/start-connect.php?socialmedia=sohuweibo<?php echo $callback; ?>", "dcWindow","width=800,height=600,left=150,top=100,scrollbar=no,resize=no");return false;' src="<?php echo $smc_url; ?>/images/sohu_button.png" alt="使用搜狐微博登陆" /></li><?php endif; ?>
		<?php if((isset($weibotok)&&!$weibotok['163weibo'])||(isset($allows)&&(empty($allows)||$allows['163weibo']))): ?><li><img class="smc_img" onclick='window.open("<?php echo $smc_url; ?>/start-connect.php?socialmedia=163weibo<?php echo $callback; ?>", "dcWindow","width=800,height=600,left=150,top=100,scrollbar=no,resize=no");return false;' src="<?php echo $smc_url; ?>/images/163_button.png" alt="使用网易微博登陆" /></li><?php endif; ?>
		<?php if((isset($weibotok)&&!$weibotok['douban'])||(isset($allows)&&(empty($allows)||$allows['douban']))): ?><li><img class="smc_img" onclick='window.open("<?php echo $smc_url; ?>/start-connect.php?socialmedia=douban<?php echo $callback; ?>", "dcWindow","width=800,height=600,left=150,top=100,scrollbar=no,resize=no");return false;' src="<?php echo $smc_url; ?>/images/douban_button.png" alt="使用豆瓣账号登陆" /></li><?php endif; ?>
		<?php if(!is_user_logged_in()&&!empty($weiboopt)&&!$weiboopt['smc_auto_js']): ?><li><a href="http://www.qiqiboy.com/plugins/social-medias-connect/" rel="bookmark">我也想要使用此服务</a></li><?php endif; ?>
	</ul>
	<?php if(!is_user_logged_in()&&(empty($weiboopt)||$weiboopt['smc_auto_js'])): ?>
		<a id="smc_weibo_start" class="smc_btn_<?php echo $weiboopt['smc_btn_img']; ?>" title="绑定账号登陆" rel="nofollow" href="javascript:void(0);"></a>
	<?php endif; ?>
<?php
    $sc_loaded = true;
}

add_filter("get_avatar", "smc_get_avatar",10,4);
function smc_get_avatar($avatar, $id_or_email='',$size='32') { 
	if ( is_object($id_or_email) ) {
		if ( !empty($id_or_email->user_id) ) {
			$user_id = (int) $id_or_email->user_id;
		}
	} else if( is_numeric($id_or_email) ){
		$user_id = (int)$id_or_email;
	} else {
		$user = get_user_by('email', $id_or_email);
		$user_id = (int) $user->ID;
	}

	if($user_id && $smcdata = get_usermeta($user_id, 'smcdata')){
		$weibo=$smcdata['smcweibo'];
		switch($weibo){
			case 'sinaweibo':
					$out = 'http://tp3.sinaimg.cn/'.$smcdata['smcid'].'/50/1.jpg';
					break;
			case 'qqweibo':
					$out = 'http://app.qlogo.cn/mbloghead/'.$smcdata['smcid'].'/100';
					break;
			case 'douban':
					$out = 'http://img3.douban.com/icon/u'.$smcdata['smcid'].'.jpg';
					break;
			case 'sohuweibo':
					$out = $smcdata['smcid'];
					break;
			case '163weibo':
					$out = $smcdata['smcid'];
					break;
			default:return $avatar;
		}
		$avatar = "<img alt='' src='{$out}' class='avatar avatar-{$size}' height='{$size}' width='{$size}' />";
		return $avatar;
	}else {
		return $avatar;
	}
}

function sc_sinauser_to_wpuser($scid) {
  return get_user_by_meta('scid', $scid);
}

if(!function_exists('get_user_by_meta')){

	function get_user_by_meta($meta_key, $meta_value) {
	  global $wpdb;
	  $sql = "SELECT user_id FROM $wpdb->usermeta WHERE meta_key = '%s' AND meta_value = '%s'";
	  return $wpdb->get_var($wpdb->prepare($sql, $meta_key, $meta_value));
	}
	
	function get_user_by_login($user_login) {
	  global $wpdb;
	  $sql = "SELECT ID FROM $wpdb->users WHERE user_login = '%s'";
	  return $wpdb->get_var($wpdb->prepare($sql, $user_login));
	}
}

if(!function_exists('connect_login_form_login')){
	add_action("login_form_login", "connect_login_form_login");
	add_action("login_form_register", "connect_login_form_login");
	function connect_login_form_login(){
		if(is_user_logged_in()){
			$redirect_to = admin_url('profile.php');
			wp_safe_redirect($redirect_to);
		}
	}
}

add_action('admin_menu', 'smc_options_add_page');
function smc_options_add_page() {
	add_options_page('SocialMedias Options', '社交媒体网站账号绑定', 'manage_options', 'smc_options', 'smc_options_do_page');
}

function smc_options_do_page() {
	if(isset($_GET['delete_all'])){
		delete_option('weibo_access_token');
		$info='你已经删除了所有绑定！';
	}elseif(isset($_GET['delete'])) {
		$weibotok=get_option('weibo_access_token');
		$weibo=trim($_GET['delete']);
		unset($weibotok[$weibo]);
		update_option('weibo_access_token',$weibotok);
		$info='你已经删除了'.$_GET['weiboname'].'的绑定！';
	}elseif(isset($_GET['oauth_token'])){
		switch($_SESSION["smc_weibo"]){
			case 'sinaweibo':
					include dirname(__FILE__).'/sinaweibo/sinaOAuth.php';
					$tok = smc_sina_getAccessToken($_REQUEST['oauth_verifier'],$_GET['oauth_token'],$_SESSION['smc_oauth_token_secret']);
					break;
			case 'qqweibo':
					include dirname(__FILE__).'/qqweibo/qqOAuth.php';
					$tok = smc_qq_getAccessToken($_REQUEST['oauth_verifier'],$_GET['oauth_token'],$_SESSION['smc_oauth_token_secret']);
					break;
			case 'douban':
					include dirname(__FILE__).'/douban/doubanOAuth.php';
					$tok = smc_douban_getAccessToken($_REQUEST['oauth_verifier'],$_GET['oauth_token'],$_SESSION['smc_oauth_token_secret']);
					break;
			case 'sohuweibo':
					include dirname(__FILE__).'/sohuweibo/sohuOAuth.php';
					$tok = smc_sohu_getAccessToken($_REQUEST['oauth_verifier'],$_GET['oauth_token'],$_SESSION['smc_oauth_token_secret']);
					break;
			case '163weibo':
					include dirname(__FILE__).'/163weibo/163OAuth.php';
					$tok = smc_163_getAccessToken($_REQUEST['oauth_verifier'],$_GET['oauth_token'],$_SESSION['smc_oauth_token_secret']);
					break;
			default:return;
		}
		$weibotok=get_option('weibo_access_token');
		$weibotok[$_SESSION["smc_weibo"]]=$tok;
		update_option('weibo_access_token',$weibotok);
	}
	?>
	<div class="wrap" style="-webkit-text-size-adjust:none;">
	<div class="icon32" id="icon-options-general"><br></div>
			<h2>绑定社交网站账号</h2>
			
            <?php
				if(isset($info)){
					echo "<h3 class='info'>$info</h3>";
				}
				$tok = get_option('weibo_access_token');//print_r($tok);//die();
				$smc_url = WP_PLUGIN_URL.'/'.dirname(plugin_basename (__FILE__));
				if($tok){
					echo '<h3>您已经绑定以下网站: </h3>';
					echo '<div id="weibobind">';
					if($tok['sinaweibo'])echo '<img class="smc_img" src="'.$smc_url.'/images/sina.png" /><a href="'.menu_page_url('smc_options',false).'&delete=sinaweibo&weiboname=新浪微博"><input type="submit" class="button-primary" value="删除新浪微博绑定"></a>';
					if($tok['qqweibo'])echo '<img class="smc_img" src="'.$smc_url.'/images/qq.png" /><a href="'.menu_page_url('smc_options',false).'&delete=qqweibo&weiboname=腾讯微博"><input type="submit" class="button-primary" value="删除腾讯微博绑定"></a>';
					if($tok['sohuweibo'])echo '<img class="smc_img" src="'.$smc_url.'/images/sohu.png" /><a href="'.menu_page_url('smc_options',false).'&delete=sohuweibo&weiboname=搜狐微博"><input type="submit" class="button-primary" value="删除搜狐微博绑定"></a>';
					if($tok['163weibo'])echo '<img class="smc_img" src="'.$smc_url.'/images/163.png" /><a href="'.menu_page_url('smc_options',false).'&delete=163weibo&weiboname=网易微博"><input type="submit" class="button-primary" value="删除网易微博绑定"></a>';
					if($tok['douban'])echo '<img class="smc_img" src="'.$smc_url.'/images/douban.png" /><a href="'.menu_page_url('smc_options',false).'&delete=douban&weiboname=豆瓣微博"><input type="submit" class="button-primary" value="删除豆瓣绑定"></a>';
					echo '</div>';
				}
				if(count($tok)>=5){
					echo '<p>你已经绑定了所有网站，点击下面按钮解除所有绑定</p>';
				}else{
					echo '<p>点击下面的图标，将你的帐号和你的博客绑定，当你的博客更新的时候，会同时更新到新浪微博。</p>';
				}
				smc_connect(array('admin'=>1,'callback_url'=>menu_page_url('smc_options',false)));
				if($tok){
			?>
				<a href="<?php echo menu_page_url('smc_options',false); ?>&delete_all=1"><input type="submit" class="button-primary" value="删除所有绑定"></a>
			<?php
				}

			?><br><br>
			<hr/>
			<div class="icon32" id="icon-options-general"><br></div>
			<h2>使用社交网站账号登陆</h2>
			<?php
				if(isset($_POST['smc_allowed_weibo'])){
					$allows=get_option('smc_allowed_weibo');
					if($allows){
						foreach($allows as $key => $t){
							if(isset($_POST['smc_allowed_'.$key])){
								$allows[$key]='1';
							}else{
								$allows[$key]='0';
							}
						}
						$info1='设置成功！';
						update_option('smc_allowed_weibo',$allows);
					}else{
						$info1='设置失败，请刷新页面重试!';
					}
				}
				$allows = get_option('smc_allowed_weibo');
				if(!$allows||count($allows)<5){
					$allows=array(
						'sinaweibo'=>'1',
						'qqweibo'=>'1',
						'sohuweibo'=>'1',
						'163weibo'=>'1',
						'douban'=>'1'
					);
					update_option('smc_allowed_weibo',$allows);
				}
				/* 微博设置 */
				$opt=get_option('smc_weibo_options');
				if(empty($opt)||count($opt)<6){
					$_opt=array(
						'smc_auto_connect'=>'1',
						'smc_auto_js'=>'1',
						'smc_weibo_notice'=>'使用微博连接登陆后，您在本站的评论将会默认同步到您的微博账户。如果不希望同步，请在评论前去掉选择"同步到XXX微博"选项。',
						'smc_btn_img'=>'1',
						'smc_front_prefix'=>'【博客更新】',
						'smc_end_prefix'=>'【博文修改】'
					);
					if($opt)$_opt=array_merge($_opt,$opt);
					update_option('smc_weibo_options',$_opt);
					$opt=get_option('smc_weibo_options');
				}
				if(isset($_POST['smc_weibo_option'])){
					foreach($opt as $key => $t){
						if(isset($_POST[$key])){
							$opt[$key]=stripslashes($_POST[$key]);
						}
					}
					update_option('smc_weibo_options',$opt);
				}
			?>
			<form action="<?php echo menu_page_url('smc_options',false); ?>" enctype="multipart/form-data" method="post">
				<?php if(isset($info1)){
						echo "<h3 class='info'>$info1</h3>";
					}
				?>
				<h3>勾选允许连接登陆的网站</h3>
				<table class="form-table">
					<tbody>
						<tr valign="top">
							<th scope="row">允许的网站请打上勾<br/></th>
							<td>
								<ul id="smc_allow">
								<?php foreach($allows as $key => $t): ?>
									<li class="smc_<?php echo $key; ?>">
										<input type="checkbox" name="smc_allowed_<?php echo $key; ?>"<?php if($t)echo ' checked="checked"'; ?> value="1" />
									</li>
								<?php endforeach; ?>
								</ul>
								<input type="hidden" name="smc_allowed_weibo" value="1" />
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">自动插入社交媒体连接按钮<br/><br/><small>1.如果选择"是"，将会自动在评论表单、登陆界面处插入连接按钮</small><br/><small>2.如果你选择“否”，那么你需要手动在需要显示连接按钮的地方调用<code>&lt;?php if(function_exists('smc_connect'))smc_connect(); ?></code></small></th>
							<td>
								<input type="radio" name="smc_auto_connect"<?php if($opt['smc_auto_connect'])echo ' checked="checked"'; ?> value="1" /><label>是</label>
								<input type="radio" name="smc_auto_connect"<?php if(!$opt['smc_auto_connect'])echo ' checked="checked"'; ?> value="0" /><label>否</label>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">启用浮动面板<br/><br/><small>1.如果选择"是"，将会在一个浮动窗口中显示登陆连接按钮（节省页面空间）</small><br/><small>2.如果你选择“否”，登陆连接按钮将会全部列出（占地方）</small></th>
							<td>
								<input type="radio" name="smc_auto_js"<?php if($opt['smc_auto_js'])echo ' checked="checked"'; ?> value="1" /><label>是</label>
								<input type="radio" name="smc_auto_js"<?php if(!$opt['smc_auto_js'])echo ' checked="checked"'; ?> value="0" /><label>否</label>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">选择按钮样式<br/><small>只有你选择了“启用浮动面板，这项选择才有效</small></th>
							<td>
								<input type="radio" name="smc_btn_img"<?php if($opt['smc_btn_img']=='1')echo ' checked="checked"'; ?> value="1" /><label><img alt="img 1" src="<?php echo $smc_url; ?>/images/smc_1.png"/></label>
								<input type="radio" name="smc_btn_img"<?php if($opt['smc_btn_img']=='2')echo ' checked="checked"'; ?> value="2" /><img alt="img 2" src="<?php echo $smc_url; ?>/images/smc_2.png"/></label>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">浮动面板右边提示文字</th>
							<td>
								<textarea name="smc_weibo_notice" cols="50" rows="3" id="smc_weibo_notice" style="width:500px;font-size:12px;" class="code"><?php echo htmlspecialchars($opt['smc_weibo_notice']); ?></textarea>
							</td>
						</tr>
					</tbody>
				</table>
				<h3>同步到微博文字前缀</h3>
				<table class="form-table">
					<tbody>
						<tr valign="top">
							<th scope="row">发布新文章时</th>
							<td>
								<input name="smc_front_prefix" class="regular-text" value="<?php echo htmlspecialchars($opt['smc_front_prefix']); ?>" />
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">修改早期文章时</th>
							<td>
								<input name="smc_end_prefix" class="regular-text" value="<?php echo htmlspecialchars($opt['smc_end_prefix']); ?>" />
							</td>
						</tr>
					</tbody>
				</table>
				<p class="submit">
					<input type="submit" name="option_save" class="button-primary" value="保存设置" />
					<input type="hidden" name="smc_weibo_option" value="1" />
				</p>
			</form><br><br><br><br>
			<hr/>
			<div>
				<h3>插件信息</h3>
				<p><b>插件名称：</b>Social Medias Connect<br/>
				<b>插件作者：</b>qiqiboy<br/>
				<b>插件地址：</b>wordpress官方下载页面<a href="http://wordpress.org/extend/plugins/social-medias-connect/">WordPress Download</a> | 作者博客发布页面<a href="http://www.qiqiboy.com/plugins/social-medias-connect/">插件发布页面</a><br/>
				<b>插件描述：</b>提供wordpress与各大微博网站的连接登陆功能，以及同步文章信息到微博，转发文章的评论到微博。</p>
				<h3>关于插件的一些FAQ</h3>
				<p>1. 问：启用插件为什么没有任何效果？
					答：请确认评论模板中有<code>&lt;?php do_action('comment_form', $post->ID); ?></code>代码，没有的话要加上。
				</p>
				<p>2. 问：启用插件wordpress报错？
					答：请确认评论wordpress版本>3.0。
				</p>
				<p>3. 问：为什么微博连接注册用户的用户名都是 sina_t_ sohu_t_ 等开头？
					答：为了保证wp既有用户的安全。
				</p>
				<p>4. 问：微博连接能和现有的用户账户绑定吗？
					答：暂时不行。未来会推出微博绑定服务。
				</p>
				<h3>微博与我交流(欢迎Follow我)</h3>
				新浪微博：<a href="http://weibo.com/qiqiboy">@qiqiboy</a><br/>
				腾讯微博：<a href="http://t.qq..com/imqiqiboy">@imqiqiboy</a><br/>
				Twitter：<a href="http://twitter.com/qiqiboy">@qiqiboy</a>
			</div>
	</div></div>
	<?php
}
/* sync your entry to social media sites */
add_action('publish_post', 'smc_publish_post', 0);
function smc_publish_post($post_ID=""){
	$weibotok = get_option('weibo_access_token');
	$weiboopt=get_option('smc_weibo_options');
	if(!$weibotok) return;
	$_post=get_post($post_ID);
	$text = $_post->post_title.' - '.get_permalink($post_ID);
	$thumb=smc_post_thumb($_post);
	$mustsync=$_POST['smc_must_sync'];
	$prefix=$weiboopt['smc_front_prefix'];
	foreach($weibotok as $weibo => $tok){
		if(get_post_meta($post_ID, '_'.$weibo.'_sync', true) && ($prefix=$weiboopt['smc_end_prefix']) && (!$mustsync || $mustsync == 'no')){
			continue;
		}
		$content=$prefix.$text;
		switch($weibo){
			case 'sinaweibo':
					include dirname(__FILE__).'/sinaweibo/sinaOAuth.php';
					$resp=smc_sina_weibo_update($content,$thumb,$tok);//print_r($resp);
					break;
			case 'qqweibo':
					include dirname(__FILE__).'/qqweibo/qqOAuth.php';
					$resp=smc_qq_weibo_update($content,$thumb,$tok);//print_r($resp);
					break;
			case 'douban':
					include dirname(__FILE__).'/douban/doubanOAuth.php';
					$resp=smc_douban_weibo_update($content,$thumb,$tok);
					break;
			case 'sohuweibo':
					include dirname(__FILE__).'/sohuweibo/sohuOAuth.php';
					$resp=smc_sohu_weibo_update($_post->post_title,$thumb,$tok);
					break;
			case '163weibo':
					include dirname(__FILE__).'/163weibo/163OAuth.php';
					$resp=smc_163_weibo_update($content,$thumb,$tok);
					break;
			default:break;
		}
		if($resp){
			if(!update_post_meta($post_ID, '_'.$weibo.'_sync', 'true'))
				add_post_meta($post_ID, '_'.$weibo.'_sync', 'true', true);
			if(!update_post_meta($post_ID, '_'.$weibo.'_sync_id', $resp))
				add_post_meta($post_ID, '_'.$weibo.'_sync_id', $resp, true);//9105332181
		}
	}
}
//smc_publish_post(3033);
/* sync comment tosocial media sites */
add_action('comment_post', 'smc_comment_post',999);
function smc_comment_post($id){
	$comment_post_id = $_POST['comment_post_ID'];
	if(empty($comment_post_id)){
		return;
	}
	$current_comment = get_comment($id);
	$current_post = get_post($comment_post_id);
	$smcdata = get_user_meta($current_comment->user_id, 'smcdata',true);
	$weibo=$smcdata['smcweibo'];
	if($smcdata){
		if($_POST['post_to_socialmedias']){
			$p=array(
				"title"=>get_the_title($comment_post_id),
				"url"=>get_permalink($comment_post_id)."#comment-".$id,
				"comment"=>strip_tags($current_comment->comment_content),
				"weibosync"=>get_post_meta($comment_post_id, '_'.$weibo.'_sync_id', true)
			);//print_r($p);die();
			switch($smcdata['smcweibo']){
				case 'sinaweibo':
						include dirname(__FILE__).'/sinaweibo/sinaOAuth.php';
						smc_sina_weibo_repost($p,$smcdata);
						break;
				case 'qqweibo':
						include dirname(__FILE__).'/qqweibo/qqOAuth.php';
						smc_qq_weibo_repost($p,$smcdata);
						break;
				case 'douban':
						include dirname(__FILE__).'/douban/doubanOAuth.php';
						smc_douban_weibo_repost($p,$smcdata);
						break;
				case 'sohuweibo':
						include dirname(__FILE__).'/sohuweibo/sohuOAuth.php';
						smc_sohu_weibo_repost($p,$smcdata);
						break;
				case '163weibo':
						include dirname(__FILE__).'/163weibo/163OAuth.php';
						smc_163_weibo_repost($p,$smcdata);
						break;
				default:continue;
			}
		}
	}
}

function smc_weibo_must_sync(){
	global $post;

	echo '<div class="postbox">';
	echo	'<h3 class="hndle"><span>强制同步文章更新</span></h3>';
	echo		'<div class="inside">';
	echo			'<b>同步到社交网站: </b><input type="radio" name="smc_must_sync" value="no"';
	echo 			' checked="checked"';
	echo 			'/><label>不同步</label> ';
	echo			'<input type="radio" name="smc_must_sync" value="yes"';
	echo 			'/><label>同步</label> ';
	echo		'</div>';
	echo '</div>';
}
//add_action('save_post', 'smc_weibo_action');
add_action('edit_form_advanced', 'smc_weibo_must_sync');

function smc_post_thumb($post=false ){
    if(!$post)global $post;

	$timthumb_src='';
	if( smc_has_post_thumbnail($post->ID)){
		$timthumbs = wp_get_attachment_image_src(smc_get_post_thumbnail_id($post->ID),'full');
		$timthumb_src=$timthumbs[0];
	}else{
		preg_match('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $index_matches);
		$first_img_src = $index_matches [1];
		if($first_img_src){
			$timthumb_src=$first_img_src;
		}
	}
	return $timthumb_src;
}
function smc_has_post_thumbnail( $post_id = NULL ) {
	global $id;
	$post_id = ( NULL === $post_id ) ? $id : $post_id;
	return !! smc_get_post_thumbnail_id( $post_id );
}
function smc_get_post_thumbnail_id( $post_id = NULL ) {
	global $id;
	$post_id = ( NULL === $post_id ) ? $id : $post_id;
	return get_post_meta( $post_id, '_thumbnail_id', true );
}
function smc_get_client_ip(){
	if(getenv('HTTP_CLIENT_IP')){
		$client_ip = getenv('HTTP_CLIENT_IP');
	} elseif(getenv('HTTP_X_FORWARDED_FOR')) {
		$client_ip = getenv('HTTP_X_FORWARDED_FOR');
	} elseif(getenv('REMOTE_ADDR')) {
		$client_ip = getenv('REMOTE_ADDR');
	} else {
		$client_ip = $HTTP_SERVER_VARS['REMOTE_ADDR'];
	}
	return $client_ip;
}
function smc_new_user_email($userdata=array(),$name){
	$blogname = get_option('blogname');
	$uname=$userdata['display_name'];
	$ulogin=$userdata['user_login'];
	$uurl=$userdata['user_url'];
	$subj = "新的{$name}连接用户注册 - $blogname";
	$body = "在 $blogname 新注册用户信息：\r\n";
	$body.= "用户名：$ulogin\r\n";
	$body.= "昵称：$uname\r\n";
	$body.= "地址：$uurl\r\n";
	$body.= "\r\n";
	$body.= "-----------------------------------\r\n";
	$body.= "这是一封自动发送的邮件。 \r\n";
	$body.= "来自 {$blogname}。\r\n";
	$body.= "请不要回复本邮件。\r\n";
	$admin_email = get_option('admin_email');
	wp_mail($admin_email, $subj, $body, $headers = '');
}